#include <bios.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#define ESC_KEY 283
#define I_KEY 5993
#define P_KEY 6512
#define IN 0
#define OUT 1
float XSCALE = 35, YSCALE = 35;
float q=1, X0=0, Y0=0;
float eps=0.03;

class vector{
   public:
   float x, y, vx, vy;
   vector(){
       x = 0;
       y = 0;
       vx = 0;
       vy = 0;
   }
   vector(float ax, float ay, float avx, float avy){
       x = ax;
       y = ay;
       vx = avx;
       vy = avy;
   }
   void out(){
       printf("x=%f\t", x);
       printf("y=%f\t", y);
       printf("vx=%f\t", vx);
       printf("vy=%f\t", vy);
   }
};
vector operator +(vector a, vector b){
   vector c;
   c.x = a.x + b.x;
   c.y = a.y + b.y;
   c.vx = a.vx + b.vx;
   c.vy = a.vy + b.vy;
   return(c);
}
vector operator -(vector a, vector b){
   vector c;
   c.x = a.x - b.x;
   c.y = a.y - b.y;
   c.vx = a.vx - b.vx;
   c.vy = a.vy - b.vy;
   return(c);
}
vector operator *(float a, vector b){
   vector c;
   c.x = a * b.x;
   c.y = a * b.y;
   c.vx = a * b.vx;
   c.vy = a * b.vy;
   return(c);
}
vector operator *(vector b, float a){
   vector c;
   c.x = a * b.x;
   c.y = a * b.y;
   c.vx = a * b.vx;
   c.vy = a * b.vy;
   return(c);
}
vector f(vector u, float t){
   vector res;
   float r;
   res.x = u.vx;
   res.y = u.vy;
   r = sqrt((u.x - X0)*(u.x - X0) + (u.y - Y0)*(u.y - Y0));
   res.vx = - q/(pow(r, 3+eps)) * u.x;
   res.vy = - q/(pow(r, 3+eps)) * u.y;
   return(res);
}
void main(){
   vector k1, k2, k3, k4;
   float dt = 0.02, t=0;
   float r=0, prevr = 0;
   vector u(1, 0, 0, -1.3);
   int direc=OUT;
   int gd=VGA, gm=VGAHI;
   initgraph(&gd, &gm, "egavga.bgi");
   while(1){
       if(bioskey(1)!=0){
	   int key = bioskey(0);
	   if(key==ESC_KEY) break;
	   if(key==I_KEY){
	       u.vx = -u.vx;
	       u.vy = -u.vy;
	   }
       }
       //⠥  - 
       putpixel(320 + u.x*XSCALE, 240 - u.y*YSCALE, WHITE);
       //ﭨ  ⥪騩 㣮 ⠥  न⠬

       r = sqrt((u.x - X0)*(u.x - X0) + (u.y - Y0)*(u.y - Y0));

       if(r < prevr && direc == OUT){
	   direc = IN;
       }
       if(r > prevr && direc == IN){
	   direc = OUT;
       }

       k1 = f(u, t)*dt;
       k2 = f(u + 0.5*k1, t+dt/2)*dt;
       k3 = f(u + 0.5*k2, t+dt/2)*dt;
       k4 = f(u + k3, t+dt)*dt;
       u = u + 1.0/6.0 * (k1 + 2*k2 + 2*k3 + k4);
       t += dt;
   }
   outtextxy(10,10, "Press any key to continue");
   getch();
   closegraph();
}